;;
;; web-static.scm
;;
;; Exporting members status for displaying in dokuwiki hack.
;;
;; ISC License
;;
;; Copyright 2023 Brmlab, z.s.
;; Dominik Pantůček <dominik.pantucek@trustica.cz>
;;
;; Permission to use, copy, modify, and/or distribute this software
;; for any purpose with or without fee is hereby granted, provided
;; that the above copyright notice and this permission notice appear
;; in all copies.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL
;; WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED
;; WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE
;; AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR
;; CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS
;; OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
;; NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
;; CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
;;

(declare (unit web-static))

(module
 web-static
 (
  gen-web-static-member
  )

 (import scheme
	 (chicken base)
	 (chicken format)
	 member-record)

 ;; Generate all the files in current directory, should be wrapped in
 ;; something like with-current-directory.
 (define (gen-web-static-member mr)
   (let ((nick (member-nick mr))
	 (id (member-id mr)))
     (with-output-to-file (sprintf "~A.id" nick)
       (lambda ()
	 (print id)))
     (with-output-to-file (sprintf "~A.balance" nick)
       (lambda ()
	 (print (member-total-balance mr))))
     (with-output-to-file (sprintf "~A.misc" nick)
       (lambda ()
	 (let loop ((lines (member-source mr)))
	   (when (not (null? lines))
	     (print (car lines))
	     (loop (cdr lines))))))
     ))

 )
